<?php
/*
Plugin Name: Recommendit
Plugin URI: http://www.webministerium.de/artikel/32/recommendit.html
Description: Recommendit - Let your visitors recommend your posts.
Version: 1.2
Author: Tobias Orterer
Author URI: http://www.webministerium.de
Install:
1. Copy recommendit.php to the Plugin folder in Wordpress
2. Activate the Plugin in the Wordpress Plugins list
3. Add this code in the index.php _before_ any code
	<?php if(!isset($_SESSION['recpost'])) { session_start(); session_register('recpost'); $_SESSION['recpost'][0] = -1; } ?>
4. Add the following code where you want the "Recommend this Article" button in your single.php
	<?php RecommenditPlugin(); ?>
5. Add this in the sidebar.php
	<li><h2>Recommended</h2>
		<ul>
			<?php get_recommends(); ?>
		</ul>
	</li>
   You can use get_recommends( 5 ); or get_recommends( 5, 60 ); for the limit of the rows
   and the character limit (cutted with '...')
6. To style everything add div#recommendit, form#recommenditform and input#recommenditbutton into your css file

##############################################
updates:
v1.2 - 2007/03/12: 
 - fixed the stupid bugs i made from the first version with the missing ID in the output function
 - added the function "get_overview()" submitted by Manuel M. Almeida (http://mangasverdes.es) to display 
   the x most recommended stories on a page including the content - thx manuel ;)
 - added the output of the number of recommendations in both output functions

*/

function install_recit() {
  	global $wpdb, $table_prefix;
  	$table_name = $table_prefix.'recit';
	if( $wpdb->get_var( 'show tables like "'.$table_name.'"' ) != $table_name ) {
	  	$q = 'CREATE TABLE `'.$table_name.'` (
			`id_post` bigint(20) NOT NULL default "0",
			`rec` int(11) NOT NULL default "0",
			PRIMARY KEY  (`id_post`)
			);';
  		require_once( ABSPATH.'wp-admin/upgrade-functions.php' );
	  	dbDelta( $q );
	}
}

function recit( $p ) {
	echo '<div id="recommendit">';
	if( array_search( $p, $_SESSION['recpost'] ) != NULL ) {
		echo 'You recommended this Post.';
	}
	else {
		echo '<form name="recommendit" method="POST" action="'.$PHP_SELF.'" id="recommenditform">';
		echo '<input type="submit" name="recommendit" value="Recommend this Article" id="recommenditbutton" />';
		echo '</form>';
	}
	echo '</div>';
}

function recommend( $post ) {
	global $wpdb, $table_prefix;
	if( array_search( $post, $_SESSION['recpost'] ) == NULL && is_numeric( $post ) ) {
		$r = mysql_query( 'SELECT * FROM '.$table_prefix.'recit WHERE id_post = '.$post );
		if( mysql_num_rows( $r ) == 0 ) {
			$q = 'INSERT INTO '.$table_prefix.'recit SET rec = rec+1, id_post = '.$post;
		}
		else {
			$q = 'UPDATE '.$table_prefix.'recit SET rec = rec+1 WHERE id_post = '.$post;
		}
		$wpdb->query( $q );
		$_SESSION['recpost'][] = $post;
	}
}

function get_recommends( $limit = 5, $chars = 0 ) {
	global $wpdb, $table_prefix;
	$recs = $wpdb->get_results( 'SELECT p.ID,p.post_title,r.rec FROM '.$table_prefix.'recit AS r, '.$table_prefix.'posts AS p WHERE p.ID = r.id_post AND p.post_password = "" AND p.post_date < "'.current_time('mysql').'" AND p.post_status = "publish" ORDER BY r.rec DESC LIMIT '.(int)$limit );
	if( $recs ) {
		foreach( $recs as $post ) {
			$post_title = html_entity_decode(stripslashes($post->post_title));
			echo '<li><a href="'.get_permalink($post->ID).'">'.snippet_chars( $post_title, $chars ).' ('.$post->rec.')</a></li>';
		}
	}
}

function RecommenditPlugin() {
	global $wp_query;
	$p = $wp_query->post->ID;
	if( !is_home() ) {
		if( is_numeric( $p ) ) {
			if( array_search( $p, $_SESSION['recpost'] ) == NULL ) {
				if( !empty( $_POST['recommendit'] ) ) {
					recommend( $p );
				}
			}
			recit( $p );
		}
		else {
			echo '<b>Recommendit Plugin Warning:</b><br />Did you insert the correct code in the index.php? ;)<hr />';
		}
	}
}

if( !function_exists( 'snippet_chars' ) ) {
	function snippet_chars( $text, $length = 0 ) {
		$text = htmlspecialchars_decode( $text );
		if( strlen( $text) > $length && $length != 0 ) {
			return htmlspecialchars( substr( $text, 0, $length ) ).'...';
		}
		else {
			return htmlspecialchars( $text );
		}
	}
}

if( !function_exists( 'htmlspecialchars_decode' ) ) {
	function htmlspecialchars_decode( $text ) {
		return strtr( $text, array_flip( get_html_translation_table( HTML_SPECIALCHARS ) ) );
	}
}

if( isset( $_GET['activate'] ) && $_GET['activate'] == 'true' ) {
	add_action( 'init', 'install_recit' );
}

function get_overview( $limit = 10 ) {
	global $wpdb, $table_prefix;
	$recs = $wpdb->get_results( 'SELECT p.ID,p.post_title,p.post_content,r.rec FROM '.$table_prefix.'recit AS r, '.$table_prefix.'posts AS p WHERE p.ID = r.id_post AND p.post_password = "" AND p.post_date < "'.current_time('mysql').'" AND p.post_status = "publish" ORDER BY r.rec DESC LIMIT '.(int)$limit );
	if( $recs ) {
		foreach( $recs as $post ) {
			$post_title = htmlspecialchars(html_entity_decode(stripslashes($post->post_title)));
			$post_content = htmlspecialchars(html_entity_decode(stripslashes($post->post_content)));
			echo '<h4><a href="'.get_permalink($post->ID).'">'.$post_title.'</a> ('.$post->rec.')</h4>';
			echo '<div class="post">';
			echo '<div class="entry">'.$post_content.'</div>';
			echo '</div>';
		}
	}
}

?>
